/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package perpus;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.Statement;
import java.awt.Dimension;
import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import perpus.laporandatabuku;
import perpus.config;
import perpus.dataanggota;
import perpus.datakembalian;
import perpus.menu_utama;
import perpus.datapeminjaman;

/**
 *
 * @author Asus
 */
public class databuku extends javax.swing.JFrame {
private Connection con;
private Statement stat;
private ResultSet res;
private String t;
private PreparedStatement pst;
private void koneksi(){
try {
Class.forName("com.mysql.jdbc.Driver");
con=(Connection) DriverManager.getConnection("jdbc:mysql://localhost/db_perpustakaan", "root", "");
stat=(Statement) con.createStatement();
} catch (ClassNotFoundException | SQLException e) {
JOptionPane.showMessageDialog(null, e);
}
}

private void kosongkan()
{ 

kd_buku.setText("");
judul.setText("");
pengarang.setText("");
penerbit.setText("");
kategori.setText("");
jumlah.setText("");
nomor.setText("");

 } 

    /**
     * Creates new form Pembeli
     */
    public databuku() {
        initComponents();
        koneksi();
        kosongkan();
        tabel();
        id_auto();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = getSize();
        setLocation(
        (screenSize.width - frameSize.width) / 2,
        (screenSize.height - frameSize.height) / 2);
    }
private void id_auto(){
    try{
            java.sql.Connection conn = (Connection) config.configDB();
            java.sql.Statement stm = conn.createStatement();
            String sql = "select max(right(kdbuku,4)) as no from databuku";
            java.sql.ResultSet res = stm.executeQuery(sql);
            while (res.next()){
                if (res.first() == false){
                   kd_buku.setText("BKU001");
                }else{
                       res.last();
                       int set_id = res.getInt(1)+1;
                       String no = String.valueOf(set_id);
                       int id_next = no.length();
                       for (int a = 0 ; a <4 - id_next; a++){
                           no = "0" + no;
                       }
                       kd_buku.setText("BKU" + no);
                }
                
            }
    } catch (SQLException ex) {
      //  Logger.getLogger(datapeminjaman.class.getName()).log(Level.SEVERE, null, ex);
    }
}
private void tabel(){ 
DefaultTableModel t= new DefaultTableModel();
 
 t.addColumn("Kode Buku"); 
 t.addColumn("Judul");
 t.addColumn("Pengarang");
 t.addColumn("Penerbit");
 t.addColumn("Kategori");
 t.addColumn("Jumlah");
 t.addColumn("Nomor");
 tbl.setModel(t); try{ res=stat.executeQuery("select * from databuku"); 
 while (res.next()) { 
 t.addRow(new Object[]{
     
  res.getString("kdbuku"),   
  res.getString("judul"),
  res.getString("pengarang"),
  res.getString("penerbit"),
  res.getString("kategori"),
  res.getString("jumlah"),
 res.getString("no") 
 }); 
 }
 }catch (Exception e) { 
 JOptionPane.showMessageDialog(rootPane, e); 
 } 
}

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        judul = new javax.swing.JTextField();
        pengarang = new javax.swing.JTextField();
        btedit = new javax.swing.JButton();
        bthapus = new javax.swing.JButton();
        btsimpan = new javax.swing.JButton();
        btkembali = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        tbl = new javax.swing.JTable();
        kd_buku = new javax.swing.JTextField();
        penerbit = new javax.swing.JTextField();
        kategori = new javax.swing.JTextField();
        jumlah = new javax.swing.JTextField();
        nomor = new javax.swing.JTextField();
        caribuku = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(0, 204, 204));

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setForeground(new java.awt.Color(0, 20, 0));
        jPanel1.setMaximumSize(new java.awt.Dimension(1000, 667));
        jPanel1.setMinimumSize(new java.awt.Dimension(1000, 667));
        jPanel1.setPreferredSize(new java.awt.Dimension(1000, 667));
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        judul.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                judulActionPerformed(evt);
            }
        });
        jPanel1.add(judul, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 190, 190, 30));

        pengarang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pengarangActionPerformed(evt);
            }
        });
        jPanel1.add(pengarang, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 240, 190, 30));

        btedit.setContentAreaFilled(false);
        btedit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btedit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btedit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bteditActionPerformed(evt);
            }
        });
        jPanel1.add(btedit, new org.netbeans.lib.awtextra.AbsoluteConstraints(104, 360, 130, 40));

        bthapus.setContentAreaFilled(false);
        bthapus.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        bthapus.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        bthapus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bthapusActionPerformed(evt);
            }
        });
        jPanel1.add(bthapus, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 360, 120, 40));

        btsimpan.setContentAreaFilled(false);
        btsimpan.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btsimpan.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btsimpan.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btsimpanActionPerformed(evt);
            }
        });
        jPanel1.add(btsimpan, new org.netbeans.lib.awtextra.AbsoluteConstraints(510, 360, 110, 40));

        btkembali.setContentAreaFilled(false);
        btkembali.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btkembaliActionPerformed(evt);
            }
        });
        jPanel1.add(btkembali, new org.netbeans.lib.awtextra.AbsoluteConstraints(730, 360, 110, 40));

        tbl.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tbl.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(tbl);

        jPanel1.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 520, 620, 90));

        kd_buku.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kd_bukuActionPerformed(evt);
            }
        });
        jPanel1.add(kd_buku, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 140, 190, 30));

        penerbit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                penerbitActionPerformed(evt);
            }
        });
        jPanel1.add(penerbit, new org.netbeans.lib.awtextra.AbsoluteConstraints(330, 290, 190, 30));
        jPanel1.add(kategori, new org.netbeans.lib.awtextra.AbsoluteConstraints(680, 140, 200, 30));
        jPanel1.add(jumlah, new org.netbeans.lib.awtextra.AbsoluteConstraints(680, 190, 200, 30));
        jPanel1.add(nomor, new org.netbeans.lib.awtextra.AbsoluteConstraints(680, 240, 200, 30));
        jPanel1.add(caribuku, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 450, 170, 30));

        jButton1.setContentAreaFilled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 453, 80, 30));

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/image/databuku.jpg"))); // NOI18N
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, -1, -1));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void judulActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_judulActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_judulActionPerformed

    private void pengarangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pengarangActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_pengarangActionPerformed

    private void btkembaliActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btkembaliActionPerformed
        // TODO add your handling code here:
        new menu_utama().setVisible(true);
        dispose();
    }//GEN-LAST:event_btkembaliActionPerformed

    private void bteditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bteditActionPerformed
        // TODO add your handling code here:
        try {
            stat.executeUpdate("update databuku   set "
//                + "id='"+id.getText()+"',"
                + "kdbuku='"+kd_buku.getText()+"',"
                + "judul='"+judul.getText()+"',"
                + "pengarang='"+pengarang.getText()+"',"
                + "penerbit='"+penerbit.getText()+"',"
                + "kategori='"+kategori.getText()+"',"
                + "jumlah='"+jumlah.getText()+"',"
                + "no='"+nomor.getText()+"'"

                + " where " + "kdbuku='"+kd_buku.getText()+"'" );
            kosongkan();
            JOptionPane.showMessageDialog(rootPane, "Data berhasil Di update");
        } catch (SQLException | HeadlessException e) {
            JOptionPane.showMessageDialog(rootPane, e);
        }finally{
         tabel();
         id_auto();
        }
    }//GEN-LAST:event_bteditActionPerformed

    private void bthapusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bthapusActionPerformed
        // TODO add your handling code here:
          try { 
stat.executeUpdate("delete from databuku where " 
+ "kdbuku='"+kd_buku.getText()
+"'" ); 
kosongkan(); 
JOptionPane.showMessageDialog(null, "Berhasil");
 } catch (SQLException | HeadlessException e) { 
JOptionPane.showMessageDialog(null, "pesan salah : "+e);
 } finally{
         tabel();
         id_auto();
          }
    }//GEN-LAST:event_bthapusActionPerformed

    private void penerbitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_penerbitActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_penerbitActionPerformed

    private void tblMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblMouseClicked
     // TODO add your handling code here:
        int baris;
           baris = tbl.getSelectedRow();
      
  //      jdate.SetDate(tabel_diagnosa.getValueAt(baris,0).toString());
        kd_buku.setText(tbl.getValueAt(baris,0).toString());
        judul.setText(tbl.getValueAt(baris,1).toString());        // TODO add your handling code here:
        pengarang.setText(tbl.getValueAt(baris,2).toString());  
        penerbit.setText(tbl.getValueAt(baris,3).toString());  
        kategori.setText(tbl.getValueAt(baris,4).toString());  
        jumlah.setText(tbl.getValueAt(baris,5).toString());
        nomor.setText(tbl.getValueAt(baris,6).toString());
        //tgl_fktur.setText(tb_buku.getValueAt(baris,4).toString());        // TODO add your handling code here:
    }//GEN-LAST:event_tblMouseClicked

    private void kd_bukuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kd_bukuActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_kd_bukuActionPerformed

    private void btsimpanActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btsimpanActionPerformed
        // TODO add your handling code here:
        try {
            stat.executeUpdate("insert into  databuku values ("
                //+ "'" + id.getText()+"',"
                + "'" + kd_buku.getText()+"',"
                + "'" + judul.getText()+"',"
                + "'" + pengarang.getText()+"',"
                + "'" + penerbit.getText()+"',"
                + "'" + kategori.getText()+"',"
                + "'" + jumlah.getText()+"',"
                + "'" + nomor.getText()+ "')");
            kosongkan();
            JOptionPane.showMessageDialog(null, "Berhasil Menyimpan Data");
        } catch (SQLException | HeadlessException e) {
            JOptionPane.showMessageDialog(null, "Perintah Salah : "+e);
        }finally{
            tabel();
            id_auto();
        }
    }//GEN-LAST:event_btsimpanActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    DefaultTableModel tabelTampil1 = new DefaultTableModel();


        
        tabelTampil1.addColumn("Kode Buku");
        tabelTampil1.addColumn("Judul"); 
        tabelTampil1.addColumn("Pengarang"); 
        tabelTampil1.addColumn("Penerbit");
        tabelTampil1.addColumn("Kategori");
        tabelTampil1.addColumn("Jumlah");
        tabelTampil1.addColumn("Nomor");
       
        try{
            koneksi();
            String sql = "Select * from databuku where kdbuku like '%" + caribuku.getText() + "%'" + "or judul like '%" + caribuku.getText() + "%'";
            pst = con.prepareStatement(sql);
            res = pst.executeQuery();
            while (res.next()) {
                tabelTampil1.addRow(new Object[]{
                    res.getString(1),
                    res.getString(2),
                    res.getString(3),
                    res.getString(4),
                    res.getString(5),
                    res.getString(6),
                    res.getString(7),
                     
                });
            }
            tbl.setModel(tabelTampil1);

        }catch (Exception e){

        }        // TODO add your handling code here:
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(databuku.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(databuku.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(databuku.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(databuku.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new databuku().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btedit;
    private javax.swing.JButton bthapus;
    private javax.swing.JButton btkembali;
    private javax.swing.JButton btsimpan;
    private javax.swing.JTextField caribuku;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField judul;
    private javax.swing.JTextField jumlah;
    private javax.swing.JTextField kategori;
    private javax.swing.JTextField kd_buku;
    private javax.swing.JTextField nomor;
    private javax.swing.JTextField penerbit;
    private javax.swing.JTextField pengarang;
    private javax.swing.JTable tbl;
    // End of variables declaration//GEN-END:variables

}
